import jax.numpy as jnp


def sum_tensors(xs, shape, empty_return_none=False, dtype=None):
    xs = [x for x in xs if x is not None]
    if len(xs) > 0:
        out = xs[0].reshape(shape)
        for x in xs[1:]:
            out = out + x.reshape(shape)
        return out
    if empty_return_none:
        return None
    return jnp.zeros(shape, dtype=dtype)
